+================================================
+
+ LinuxCNC - Vectric machine output configuration file
+
+================================================
+
+ History
+
+ Who       When       What
+ ========  ========== ===========================
+ Tony      02/08/2005 Written 
+ Pieter    20/06/2008 adapted for EMC2, begin + end
+                      it uses M7 to start coolant/vacu-cleaner
+ Mark	    28/06/2008 Added Arcs and new segment section.
+ Mark      30/09/2009 Inch version
+ cncbasher 23/09/2014 Added Toolchange
+ A.Faria   15/10/2014 Added M3/M5 Spindle Start/Stop and other tweeks.
+================================================

POST_NAME = "LinuxCNC ATC Arcs(inch)(*.ngc)"

FILE_EXTENSION = "ngc"

UNITS = "INCHES"

+------------------------------------------------
+    Line terminating characters
+------------------------------------------------

LINE_ENDING = "[13][10]"

+------------------------------------------------
+    Block numbering
+------------------------------------------------

LINE_NUMBER_START     = 0
LINE_NUMBER_INCREMENT = 10
LINE_NUMBER_MAXIMUM = 999999

+================================================
+
+    Formating for variables 
+
+================================================

VAR LINE_NUMBER = [N|A|N|1.0]
VAR SPINDLE_SPEED = [S|A|S|1.0]
VAR FEED_RATE = [F|C|F|1.1]
VAR X_POSITION = [X|A|X|1.3]
VAR Y_POSITION = [Y|A|Y|1.3]
VAR Z_POSITION = [Z|C|Z|1.3]
VAR ARC_CENTRE_I_INC_POSITION = [I|A|I|1.3]
VAR ARC_CENTRE_J_INC_POSITION = [J|A|J|1.3]
VAR X_HOME_POSITION = [XH|A|X|1.3]
VAR Y_HOME_POSITION = [YH|A|Y|1.3]
VAR Z_HOME_POSITION = [ZH|A|Z|1.3]
VAR SAFE_Z_HEIGHT = [SAFEZ|A|Z|1.3]

+================================================
+
+    Block definitions for toolpath output
+
+================================================

+---------------------------------------------------
+  Commands output at the start of the file
+---------------------------------------------------

begin HEADER
"%"
" ( [TP_FILENAME] File created: [DATE] - [TIME])"
"( for LinuxCNC )"
"( Material Size) ( X= [XLENGTH], Y= [YLENGTH], Z= [ZLENGTH])"
"G91 (Incremental distance mode)" 
"G17 G20 (Active Plane: XY)(Inch Mode)" 
"G40 G49 G80(Tool Diameter, Length compensation & canned cycles off)" 
"G64 P0.05 Q0.05(Path Blending)"
"G90 (absolute distance mode)"

"T[T] M06 [TOOLNAME]"
"G43 H[T]"
"M03 [S]"
"G54 (Coordinate System)"

+---------------------------------------------------
+ Commands output for Initial rapid move 
+---------------------------------------------------
begin INITIAL_RAPID_MOVE
"G00 [X] [Y] [Z] [F]"

+---------------------------------------------------
+  Commands output for rapid moves 
+---------------------------------------------------
begin RAPID_MOVE
"G00 [X] [Y] [Z] [F]"

+---------------------------------------------------
+  Commands output for the first feed rate move
+---------------------------------------------------
begin FIRST_FEED_MOVE
"G01 [X] [Y] [Z] [F]"

+---------------------------------------------------
+  Commands output for feed rate moves
+---------------------------------------------------
begin FEED_MOVE
"G01 [X] [Y] [Z]"

+ ---------------------------------------------------
+  Commands output for First_PLUNGE Moves
+ ---------------------------------------------------
 begin FIRST_PLUNGE_MOVE
"G01 [Z] [F] M3 G4 P2"

+ ---------------------------------------------------
+  Commands output for PLUNGE Moves
+ ---------------------------------------------------
 begin PLUNGE_MOVE
"G01 [Z] [F]"

+---------------------------------------------------
+  Commands output for the first clockwise arc move
+---------------------------------------------------
begin FIRST_CW_ARC_MOVE
"G02 [X] [Y] [I] [J]"

+---------------------------------------------------
+  Commands output for clockwise arc move
+---------------------------------------------------
begin CW_ARC_MOVE
"G02 [X] [Y] [I] [J]"

+---------------------------------------------------
+  Commands output for the first counterclockwise arc move
+---------------------------------------------------
begin FIRST_CCW_ARC_MOVE
"G03 [X] [Y] [I] [J]"

+---------------------------------------------------
+  Commands output for counterclockwise arc move
+---------------------------------------------------
begin CCW_ARC_MOVE
"G03 [X] [Y] [I] [J]"

+---------------------------------------------------
+  Commands output for a new segment - toolpath
+  with same toolnumber but maybe different feedrates

+---------------------------------------------------
+  Commands output for Retract Moves
+ ---------------------------------------------------
 begin RETRACT_MOVE
"G00 [Z]"

+---------------------------------------------------
+  Commands output at toolchange
+---------------------------------------------------
begin TOOLCHANGE
"M6 T[T] [TOOLNAME]"
"G43 H[T]"
"[S] M03"

+---------------------------------------------------
+  Commands output at the end of the file
+---------------------------------------------------
begin FOOTER
"(Begin Footer)"
"G00 [ZH]"
"M30"
"(End Footer)"
"%"
